#include "taxaset.h"
#include "names.h"
#include"time.h"

#include"LEDA/matrix.h"
#include"LEDA/array.h"
#include"LEDA/vector.h"

#include"f2c.h"
#include"clapack.h"
#define DELTA 0.0000001

// WHAT

//void singular_vectors(matrix& A, vector& v1, vector& v2);


int mini(int a, int b)
{
  if(a<b) return a;
  else return b;
}

int maxi(int a, int b)
{
  if(a>b)return a;
  else return b;
}


void singular_vectors(matrix& A, vector& v1, vector& v2)
{ 
  char JOBU = 'S';
  char JOBVT = 'S';
  
  integer _M = A.dim1();// Number of rows
  integer _N = A.dim2();// NUmber of Columns in the matrics
  integer _LDA = maxi(1, _M);//Leading dimension of the array. Also equal to the number of rows in the matrics. Since the matrics now is stored in the form of a single dimensional array
  integer _NB = 2; // Optimal Block Size for Work space
  integer _LWORK = (_M+_N)*_NB;// For optimal performance
  doublereal * a; //The original matrics is stored in it in the form of an array that is one dimensional now.

  a = new double[_M * _N];// The size equal to the total number of elements

  vector temp;// Temperory used to transfer the matrics into array

  int k=0;
  for(int i=0; i<_N; ++i)
    {
      temp = A.col(i);
      for(int j=0; j<temp.dim(); j++)
	{
	  a[i*temp.dim()+j] = temp[j];
	} 
      
    }
  

  doublereal * S = new double[mini(_M, _N)];// double precision array used to store the singular values
  integer LDU = _M;
  doublereal * U = new double[LDU * mini(_M, _N)];
  integer LDVT = mini(_M, _N);
  doublereal * VT = new double[LDVT * _N];
 
  
  doublereal * _WORK = new doublereal[_LWORK];// work array 
  integer info = 0;// if correct 

  //  dgesvd_(&JOBU, &JOBVT, &_M, &_N, a, &_LDA, S, U, &LDU, VT, &LDVT, _WORK, &_LWORK, &info);
  
  //if(info == 1)
  //    cout<<"Success"<<endl;
  
  
  // conversting into the bidigonal form
  
  doublereal * _D = new doublereal[mini(_M, _N)];// First diagonal vector
  
  doublereal * _E = new doublereal[mini(_M, _N) - 1];// second diagonal vector
  
  doublereal * _TAUQ = new doublereal[mini(_M, _N)];// U1 vector First left singular vector
  
  doublereal * _TAUP = new doublereal[mini(_M, _N)];// V1T First Right singular vector transpose
  
  
  
  dgebrd_(&_M, &_N, a, &_LDA, _D, _E, _TAUQ, _TAUP, _WORK, &_LWORK, &info); 
  
  /*   if(info == 0) */
  /*     cerr<<"Succesfully created the bidiagonal form"<<endl; */
  /*   else { */
  /*     cerr<<"The bidigonal form could not be created"<<endl; */
  /*     exit; */
  //}

//Generating the real orthogonal metrics

char _VECT = 'Q'; //Since we want the left singular vectors only. 'P' in the case of the right
integer rows_in_Q = _M; //Number of rows in 'Q'
integer cols_in_Q = _M; //Number of columns in 'Q' also equal to the number of columns in the original metrics, _M if we are considering the right.
integer _K = _N;// Number of columns in the original metrics. Rows if the right 

dorgbr_(&_VECT, &rows_in_Q, &cols_in_Q, &_K, a, &_LDA, _TAUQ, _WORK, &_LWORK, &info);

/*  if(info == 0) */
/*     cerr<<"Succesfully created the orthognal form"<<endl; */
/*   else { */
/*     cerr<<"The orthognal form could not be created"<<endl; */
/*     exit; */
//}
  
  //Singular Vector Decomposition
  char _UPLO;// Upper or Lower Bigonal
  if(_M >= _N)
    _UPLO = 'U';
  else
    _UPLO = 'L';
  
  integer _size_D = mini(_M, _N);// dimensions of the Matrics B = the two diagonals
  integer _NCVT = 0;
  
  integer _NRU = _M;
  integer _NCC = 0;
  integer x = 1;
  integer y = 1;
  doublereal * dummy1;
  doublereal * dummy2;
   
  //  integer _LDU = mini(_M, _N); // diemsnions of _TAUQ i.e., U
  integer _LDU = _M;
  
    // dbdsqr_(&_UPLO, &_size_D, &_NCVT, &_NRU, &_NCC, _D, _E, dummy1, &x, _TAUQ, &_LDU,  dummy2, &y, _WORK, &info); 
    dbdsqr_(&_UPLO, &_size_D, &_NCVT, &_NRU, &_NCC, _D, _E, dummy1, &x, a, &_LDU,  dummy2, &y, _WORK, &info); 
  
/*  if(info == 0) */
/*     cerr<<"Succesfully created the SVD"<<endl; */
/*   else { */
/*     cerr<<"The SVD could not be created"<<endl; */
/*     exit; */
//}


  // updating the two singular metrics
  for(int i=0; i<_M; ++i)
    {
      v1[i] = a[i];
    }
  for(int i=0; i<_M; ++i)
    {
      v2[i] = a[i + _M];
    }
}

/* int main (const int argc,const char *argv[]) */
/* { */
  
/*   // set program options: */
/*   //  tOptions options; */
/*   //options.parse_command_line(argc,argv); */
  
/*   int rows = 4; */
/*   int columns = 2; */

/*   matrix A(rows, columns);   */
/*   //istream &ins = options.ins(); */

/*   A[0][0] = 1; */
/*   A[0][1] = 2; */
/*   A[1][0] = 3; */
/*   A[1][1] = 4; */
/*   A[2][0] = 5; */
/*   A[2][1] = 6; */
/*   A[3][0] = 7; */
/*   A[3][1] = 8; */
  
/*   vector v1(rows); */
/*   vector v2(rows); */
	
/*   singular_vectors(A, v1, v2); */

/*   for(int i=0; i<rows; ++i) */
/*     cout<<v1[i]<<"\t"<<v2[i]<<endl; */

/* } */
